#include <stdio.h>
#include <string.h>

#define PROG "KALK: Klingon ArithmeticaL Kalkulator"
#define VERS "1"
#define LVL "2"
#define DATE "January 14 2001"
/*Global Variable Dictionary*/

int debug = 0;

#define KSIZE 200
int kstack[KSIZE];
int ksptr = 0;
int silent = 0;

/*docommercial - whose program IS this?
     _                                                   _       _ 
  __| | ___   ___ ___  _ __ ___  _ __ ___   ___ _ __ ___(_) __ _| |
 / _` |/ _ \ / __/ _ \| '_ ` _ \| '_ ` _ \ / _ \ '__/ __| |/ _` | |
| (_| | (_) | (_| (_) | | | | | | | | | | |  __/ | | (__| | (_| | |
 \__,_|\___/ \___\___/|_| |_| |_|_| |_| |_|\___|_|  \___|_|\__,_|_|
                                                                   

 */
docommercial(){
  if (silent == 0){
    printf ("\n\nKlingon ArithmeticaL Kalculator  %s.%s\nJoel Peter Anderson, %s\n",VERS,LVL,DATE);
    printf ("Visit the Universal Translator Assistant Project at \n\thttp://www.MrKlingon.org\n\n");
  }
}

/*                            
 _   _ ___  __ _  __ _  ___ 
| | | / __|/ _` |/ _` |/ _ \
| |_| \__ \ (_| | (_| |  __/
 \__,_|___/\__,_|\__, |\___|
                 |___/      
*/
void usage(){
  docommercial();
  printf ("USAGE:  KALK\n--------------------------------\n");
  printf ("  ?     : this usage note\n");
  printf ("  .     : print and pop stack\n");
  printf ("  +     : add two top entries\n");
  printf ("  -     : subtract two top entries (second - top)\n");
  printf ("  x     : multiply two top entries\n");
  printf ("  /     : divide two top entries (second / top)\n");
  printf ("          top = result, second = remainder\n");
  printf ("  cha'  : duplicate top entry\n");
  printf ("  tam   : swap top entries\n");
  printf ("  legh  : view stack\n");
  printf ("  see   : view stack in base 10\n");
  printf ("  pItlh : quit program\n");
  printf ("  exit  : quit program\n");
  printf ("\ntop = top of stack");
  printf ("\nsecond = second from top");
  printf ("\n");
}



/*knum - make klingon version of decimal number
  _                          
  | | ___ __  _   _ _ __ ___  
  | |/ / '_ \| | | | '_ ` _ \ 
  |   <| | | | |_| | | | | | |
  |_|\_\_| |_|\__,_|_| |_| |_|
                            

*/
int knum(int num){

  int anum;
  int xnum = 0;
  int jnum = 0;
  int sign = 1;
  int p=1;
  if (debug) {printf("num: %d ",num);}
  if (num<0){sign  = -1;}
  num = abs(num);
  while (num > 0){
    anum = (num/3);
    jnum = num - (anum*3);
    if (jnum <1) {
      jnum=3;
      anum = anum -1;
    }
    xnum = xnum + (jnum * p);
    p = p*10;
    num = anum;
  }
  if (debug) {printf("xnum: %d\n ",xnum);}
  return (sign*xnum);

}



/*dnum - make klingon version of decimal number
     _                       
  __| |_ __  _   _ _ __ ___  
 / _` | '_ \| | | | '_ ` _ \ 
| (_| | | | | |_| | | | | | |
 \__,_|_| |_|\__,_|_| |_| |_|

 */
int dnum(int num){

  int digit;
  int xnum = 0;
  int p=1;
  if (debug) {printf("num: %d ",num);}
  if (num != 0 ){
    if (num>0){
      while (num > 0){
	digit = num - (10 * (num/10));
	if ((digit<1)||(digit > 3)){
	  printf ("ghobe'!  wa', cha, wej joq!\n");
	  return 0;
	}
	xnum = xnum + (digit * p);
	p = p*3;
	num = num/10;
      }
    }else{
      while (num < 0){
	digit = num - (10 * (num/10));
	xnum = xnum + (digit * p);
	p = p*3;
	num = num/10;
      }
    } 
    if (debug) {printf("xnum: %d\n ",xnum);}
    return xnum;
  }
}

/*
  kpop - pop top of stack
  _                      
  | | ___ __   ___  _ __  
  | |/ / '_ \ / _ \| '_ \ 
  |   <| |_) | (_) | |_) |
  |_|\_\ .__/ \___/| .__/ 
  |_|         |_|    

*/

int kpop() { 
  
  if (ksptr >0) {
    return (kstack[--ksptr]);
  }else{
    printf ("ghobe'! pagh ghajtaH \n");
    return 0;
  }
}


/*
 _       _       _   
| | ____| | ___ | |_ 
| |/ / _` |/ _ \| __|
|   < (_| | (_) | |_ 
|_|\_\__,_|\___/ \__|

kdot - pop top of stack and display
 */

int kdot() { 

  int num = kpop();
  if (num != 0) {
    printf ("%d\n",knum(num));
  }else{
    printf ("pagh\n");
  }
}


/*

 _                    _     
| | ___ __  _   _ ___| |__  
| |/ / '_ \| | | / __| '_ \ 
|   <| |_) | |_| \__ \ | | |
|_|\_\ .__/ \__,_|___/_| |_|
     |_|                    
kpush - push integer on stack
*/
void kpush(int x) { 

   if (ksptr<KSIZE){
    kstack[ksptr++]=x;
  }else{
    printf ("ghobe'! buy'chu' tetlh!  \n");
  }
}

 
/*kview - display current stack with Klingon numbering

 _           _               
| | ____   _(_) _____      __
| |/ /\ \ / / |/ _ \ \ /\ / /
|   <  \ V /| |  __/\ V  V / 
|_|\_\  \_/ |_|\___| \_/\_/  
                             

 */
void kview(){
  int i;
  printf ("\nCURRENT STACK:\n--------------------\n");
  for(i=ksptr-1;i>=0;i--){
    printf ("[%d] %d\n",knum(i),knum(kstack[i]));
  }
  printf ("--------------------\n\n");
}

/*view - view current stack in decimal notation
       _               
__   _(_) _____      __
\ \ / / |/ _ \ \ /\ / /
 \ V /| |  __/\ V  V / 
  \_/ |_|\___| \_/\_/  
                       

 */
void view(){
  int i;
  printf ("\nCURRENT STACK (base 10):\n--------------------\n");
  for(i=ksptr-1;i>=0;i--){
    printf ("[%d] %d\n",i,kstack[i]);
  }
  printf ("--------------------\n\n");
}

/*kadd - add two numbers, place result on stack
 _             _     _ 
| | ____ _  __| | __| |
| |/ / _` |/ _` |/ _` |
|   < (_| | (_| | (_| |
|_|\_\__,_|\__,_|\__,_|
                       
 */
void kadd(){
  int i,a,b;
  if (ksptr  < 2){
    printf ("error! not enough elements on stack \n");
    return;
  }
  a = kpop();
  b = kpop();
  i = a+b;
  kpush(i);

}

/*kdiv - divide two numbers, push remainder, then result on stack
 _       _ _       
| | ____| (_)_   __
| |/ / _` | \ \ / /
|   < (_| | |\ V / 
|_|\_\__,_|_| \_/  
                   
 */
void kdiv(){
  int i,j,a,b;
  if (ksptr  < 2){
    printf ("error! not enough elements on stack \n");
    return;
  }
  if (ksptr  < 2){
    printf ("ghobe
error! not enough elements on stack \n");
    return;
  }

  a = kpop();
  if (a  == 0){
    printf ("ghobe! can't divide by zero\n");
    kpush(a);
    return;
  }
  b = kpop();
  i = b/a;
  j = b - (i*a);
 
  kpush(j);
  kpush(i);

}

/*kminus subtract two numbers, place result on stack
 _              _                 
| | ___ __ ___ (_)_ __  _   _ ___ 
| |/ / '_ ` _ \| | '_ \| | | / __|
|   <| | | | | | | | | | |_| \__ \
|_|\_\_| |_| |_|_|_| |_|\__,_|___/
                                  
*/
void kminus(){
  int i, a,b;

  if (ksptr  < 2){
    printf ("error! not enough elements on stack \n");
    return;
  }
  b = kpop();
  a = kpop();
  i = a-b;
  kpush(i);
}

/*
ktime
 _    _   _                
| | _| |_(_)_ __ ___   ___ 
| |/ / __| | '_ ` _ \ / _ \
|   <| |_| | | | | | |  __/
|_|\_\\__|_|_| |_| |_|\___|
*/

void ktime(){
  int i,a,b;
  if (ksptr  < 2){
    printf ("error! not enough elements on stack \n");
    return;
  }
  a = kpop();
  b = kpop();
  i = a*b;
  kpush(i);
}

/*
kdupe - duplicate top of stack
 _       _                                             
| | ____| |_   _ _ __   ___                            
| |/ / _` | | | | '_ \ / _ \                           
|   < (_| | |_| | |_) |  __/                           
|_|\_\__,_|\__,_| .__/ \___|                           
                |_|                                    

 */
void kdupe(){
  int i;
  i = kpop();
  kpush(i);
  kpush(i);
}

/*kswap - swap top two elements of stack
 _                            
| | _______      ____ _ _ __  
| |/ / __\ \ /\ / / _` | '_ \ 
|   <\__ \\ V  V / (_| | |_) |
|_|\_\___/ \_/\_/ \__,_| .__/ 
                       |_|    
*/

void kswap(){
  int a,b;
  a = kpop();
  b = kpop();
  kpush(a);
  kpush(b);
}


/*
                   _       
   _ __ ___   __ _(_)_ __  
  | '_ ` _ \ / _` | | '_ \ 
  | | | | | | (_| | | | | |
  |_| |_| |_|\__,_|_|_| |_|

*/

main (int argc, char *argv[]) {
  int x,i;
  int done = 0;
  char inp[256];

if (argc ==1){
  usage();

  while (!done){
    printf ("\nKALK> ");
    scanf("%s",inp);
	x=0;
    if (debug) {
      printf ("inp: %s\n",inp);
    }
    if(!strcmp(".",inp))
      {kdot();continue;}
	      
    if(!strcmp("+",inp)){kadd();continue;}
    if(!strcmp("/",inp)){kdiv();continue;}
    if(!strcmp("-",inp)){kminus();continue;}
    if(!strcmp("*",inp)){ktime();continue;}
    if(!strcmp("x",inp)){ktime();continue;}
    if(!strcmp("?",inp)){usage();continue;}
    if(!strcmp("cha'",inp)){kdupe();continue;}
    if(!strcmp("tam",inp)){kswap();continue;}
    if(!strcmp("legh",inp)){kview();continue;}
    if(!strcmp("see",inp)){view();continue;}
    if(!strcmp("exit",inp)){done=1;continue;}
    if(!strcmp("pItlh",inp)){done=1;continue;}

    sscanf(inp,"%d",&x);
    if (debug) {
      printf ("x: %d\n",x);
    }
    if (x>0){
      x = dnum(x);
      if (x) {kpush(x);}
    }
  }
}else{
  for (i=1;i<argc;i++){

    sscanf(argv[i],"%s",inp);
	x=0;

	printf ("Kalk> %s\n",inp);
    if(!strcmp(".",inp)){kdot();continue;}
    if(!strcmp("+",inp)){kadd();continue;}
    if(!strcmp("/",inp)){kdiv();continue;}
    if(!strcmp("-",inp)){kminus();continue;}
    if(!strcmp("*",inp)){ktime();continue;}
    if(!strcmp("x",inp)){ktime();continue;}
    if(!strcmp("cha'",inp)){kdupe();continue;}
    if(!strcmp("tam",inp)){kswap();continue;}
    if(!strcmp("legh",inp)){kview();continue;}
    if(!strcmp("see",inp)){view();continue;}

    sscanf(inp,"%d",&x);
    if (debug) {
      printf ("x: %d\n",x);
    }
    if (x>0){
      x = dnum(x);
      if (x) {kpush(x);}
    }
  }

}
  docommercial();
}


